<?php
// Esegue in maniera Batch la copia di una tabella da un database all'altro
// Per lanciarlo da console:
//
//     php.exe -q -f RunCopyBatch.php Environment='nome-ambiente' > file.log
//        per Unix:
//     php RunCopyBatch.php "Environment='nome-ambiente'" > file.log
//
// Legge gli argomenti in input
$_pg = $argv[0];
for ($i=1; $i < count($argv); $i++) {
   $v = "\$" . $argv[$i] . ';';
   eval($v);
}
print "<pre>\r\n";
print "Copy Batch Tabelle tra database disomogenei - iniziato il " . date("d/m/Y - H:i:s") . "\r\n";

if ($Environment == '') {
   print "Manca il nome dell'ambiente di esecuzione della copia.";
   exit(99);
}
$debug = false;  // Impostare a true se si vuole debug istruzioni SQL
include($Environment);
include_once($DirADOdb . "adodb.inc.php");
if ($OK != 'Y' && $OK != 'y') {
   print "Manca l'OK per l'esecuzione della copia (Var. \$OK diversa da 'Y') - Lavoro interrotto.\r\n";
   exit(90);
}

if ($RejectFile == '') $RejectFile = 'Rejected.log';
if ($DirWork != '') $RejectFile = $DirWork . $RejectFile;
$where = '';
if (is_array($PKarr)) {
   $where = ' where ';
   for ($j = 0; $j < count($PKarr); $j++) {
      $where .= $PKarr[$j] . "='-1'";
      if ($j < (count($PKarr)-1)) $where .= ' and ';
   }
}

// Connessione ai database di Input e Output
connetti($TipoDBIn, $HostIn, $DBUserIn, $DBPasswordIn, $DBnameIn, $ADOdriverIn, 'In');
if ($dbIn->ErrorNo() != 0) {
   print "Connessione a " . $DBnameIn . " (" . $TipoDBIn . ") fallita ! \r\n" . $dbOut->ErrorNo() . ' - ' . $dbOut->ErrorMsg();
   exit ($dbIn->ErrorNo());
}

connetti($TipoDBOut, $HostOut, $DBUserOut, $DBPasswordOut, $DBnameOut, $ADOdriverOut, 'Out');
if ($dbIn->ErrorNo() != 0) {
   print "Connessione a " . $DBnameOut . " (" . $TipoDBOut . ") fallita ! \r\n" . $dbOut->ErrorNo() . ' - ' . $dbOut->ErrorMsg();
   exit ($dbOut->ErrorNo());
}

// A questo punto si e' gia' connesso ai due databases

if ($debug) {
   $dbIn->debug = true;
   $dbOut->debug = true;
}
print "(" . $DBnameIn . ") " . $SelectIn . "\r\n";
$rsIn = $dbIn->Execute($SelectIn);  $_ErrMsg = $dbIn->ErrorNo() . ' - ' . $dbIn->ErrorMsg();
if ($dbIn->ErrorNo() == 0) print "Apertura SELECT in input eseguito senza errori.\r\n";
else {
   print "Errore apertura SELECT in input: $_ErrMsg.\r\n";
   exit ($dbIn->ErrorNo());
}

$rsOut = $dbOut->Execute("SELECT * FROM " . $TabellaOut . $where);
if ($rsOut) {
    // $Insert = 'INSERT INTO ' . $TabellaOut . ' VALUES(' ;
    $nCampiTabOut = $rsOut->FieldCount() ;
    for ($i=0; $i < $nCampiTabOut; $i++) {
       $ObjCampo = $rsOut->FetchField($i);
       $nmOut[$i] = $ObjCampo->name;
       //$mlOut[$i] = $ObjCampo->max_length;
       //$tyOut[$i] = $ObjCampo->type;
       // $Insert .= '\'$rsIn->fields['.$i.']\'';
       // if ($i < ($nCampiTabOut-1)) $Insert .= ', ';
       // else $Insert .= ')';
    }
}

if ($dbOut->ErrorNo() == 0) print "Apertura $TabellaOut in output eseguita senza errori.\r\n";
else {
   print "Errore apertura $TabellaOut in output: " . $dbOut->ErrorNo() . ' - ' . $dbOut->ErrorMsg();
   exit ($dbOut->ErrorNo());
}
if ($DropTable == 'Y' || $DropTable == 'y') {
   $rs = $dbOut->Execute("DELETE FROM " . $TabellaOut);
   if ($rs===false) {
       print "Errore DELETE $TabellaOut: " . $dbOut->ErrorNo() . ' - ' . $dbOut->ErrorMsg() . "\r\n";
       if ($StopErr == 'Y' || $StopErr == 'y') { print "Lavoro interrotto.\r\n"; exit(91); }
   }
   else print "DELETE FROM $TabellaOut: eseguita con successo.\r\n";
}
$fp = @fopen($RejectFile, "w") or die ("Errore in apertura di " . $RejectFile);
fputs ($fp, "<pre>\r\nRecord scartati tra copia da " . $DBnameIn . " (" . $TipoDBIn . ") a " . $TabellaOut . " (" . $TipoDBOut . ") - " . date("d/m/Y - H:i:s") . "\r\n");

if ($TimeLimit == '' || !is_numeric($TimeLimit) || $TimeLimit < 1) set_time_limit(3600); // un ora
else set_time_limit($TimeLimit * 60);
if ($nRecMsg == '' || !is_numeric($nRecMsg) || $nRecMsg < 100) $nRecMsg = 10000;

$nRecIn = 0; $nRecOut = 0;
while (!$rsIn->EOF) {
   $nRecIn++;
   for ($i=0; $i < $nCampiTabOut; $i++) {
       $nome = $nmOut[$i];
       $Arr["$nome"] = $rsIn->fields[$i];
   }
   $InsertSQL = $dbOut->GetInsertSQL($rsOut, $Arr);
   $rs = $dbOut->Execute($InsertSQL);
   if ($rs===false) {
      print "Errore Insert $nRecIn: " . $dbOut->ErrorNo() . ' - ' . $dbOut->ErrorMsg() . "\r\n";
      fputs ($fp, $nRecIn . ": " . $InsertSQL . "\r\n");
      if ($StopReject == 'Y' || $StopReject == 'y') {
         print "Lavoro interrotto.\r\n";
         fputs ($fp, "Lavoro interrotto.\r\n");
         break;
      }
   }
   else $nRecOut++;
   if ($nRecOut > 0 && ($nRecOut % $nRecMsg) == 0) print "Sono stati copiati $nRecOut record.\r\n";
   $rsIn->MoveNext();
}
print date("H:i:s") . " - Sono state lette $nRecIn righe in input e ne sono state scritte $nRecOut su $TabellaOut.\r\n";
fclose($fp);

exit (0);

 // Si connette ad uno dei due database
function connetti($TipoDB, $Host, $DBUser, $DBPassword, $DBname, $ADOdriver, $n) { // $n pu essere 'In'  o  'Out'
   global $dbIn, $dbOut;

  if ($n == 'In') $dbIn = NewADOConnection($TipoDB);
  else $dbOut = NewADOConnection($TipoDB);

switch ($TipoDB) {
  case 'access':
    if ($n == 'In') $dbIn->Connect($DBname, $DBUser, $DBPassword) or die ($dbIn->ErrorMsg());
	  else  $dbOut->Connect($DBname, $DBUser, $DBPassword) or die ($dbOut->ErrorMsg());
    break;
  case 'odbc':
    if ($n == 'In') $dbIn->Connect($DBname, $DBUser, $DBPassword) or die ($dbIn->ErrorMsg());
	  else $dbOut->Connect($DBname, $DBUser, $DBPassword) or die ($dbOut->ErrorMsg());
    break;
  case 'ado':
    if ($n == 'In') $dbIn->Connect("PROVIDER=MSDASQL;DRIVER={$ADOdriver};SERVER=$Host;DATABASE=$DBname;UID=$DBUser;PWD=$DBPassword;") or die ($dbIn->ErrorMsg());
	  else $dbOut->Connect("PROVIDER=MSDASQL;DRIVER={$ADOdriver};SERVER=$Host;DATABASE=$DBname;UID=$DBUser;PWD=$DBPassword;") or die ($dbOut->ErrorMsg());
    break;
  case 'vfp':
    if ($n == 'In') $dbIn->Connect($DBname, $DBUser, $DBPassword) or die ($dbIn->ErrorMsg());
	  else $dbOut->Connect($DBname, $DBUser, $DBPassword) or die ($dbOut->ErrorMsg());
    break;
  case 'db2':
    if ($n == 'In') $dbIn->Connect($DBname, $DBUser, $DBPassword) or die ($dbIn->ErrorMsg());
	  else $dbOut->Connect($DBname, $DBUser, $DBPassword) or die ($dbOut->ErrorMsg());
    break;
  case 'mysql':
    if ($n == 'In') $dbIn->Connect($Host, $DBUser, $DBPassword, $DBname) or die ($dbIn->ErrorMsg());
	  else $dbOut->Connect($Host, $DBUser, $DBPassword, $DBname) or die ($dbOut->ErrorMsg());
    break;
  case 'oci8':
    if ($n == 'In') $dbIn->Connect($Host, $DBUser, $DBPassword, $DBname) or die ($dbIn->ErrorMsg());
	  else $dbOut->Connect($Host, $DBUser, $DBPassword, $DBname) or die ($dbOut->ErrorMsg());
    break;
  case 'mssql':
    if ($n == 'In') $dbIn->Connect($Host, $DBUser, $DBPassword, $DBname) or die ($dbIn->ErrorMsg());
	  else $dbOut->Connect($Host, $DBUser, $DBPassword, $DBname) or die ($dbOut->ErrorMsg());
    break;
  case 'postgres7':
    if ($n == 'In') $dbIn->Connect($Host, $DBUser, $DBPassword, $DBname) or die ($dbIn->ErrorMsg());
	  else $dbOut->Connect($Host, $DBUser, $DBPassword, $DBname) or die ($dbOut->ErrorMsg());
    break;
  case 'borland_ibase':
    if ($n == 'In') $dbIn->Connect($Host, $DBUser, $DBPassword, $DBname) or die ($dbIn->ErrorMsg());
	  else $dbOut->Connect($Host, $DBUser, $DBPassword, $DBname) or die ($dbOut->ErrorMsg());
    break;
  case 'informix':
    if ($n == 'In') $dbIn->Connect($Host, $DBUser, $DBPassword, $DBname) or die ($dbIn->ErrorMsg());
	  else $dbOut->Connect($Host, $DBUser, $DBPassword, $DBname) or die ($dbOut->ErrorMsg());
    break;
  case 'sybase':
    if ($n == 'In') $dbIn->Connect($Host, $DBUser, $DBPassword, $DBname) or die ($dbIn->ErrorMsg());
	  else $dbOut->Connect($Host, $DBUser, $DBPassword, $DBname) or die ($dbOut->ErrorMsg());
    break;
}

}


?>

